#!/usr/bin/env python

from random import randint,choice
from sys import exit
from elements import *

def answer(ans):
    print '='*72
    print "The correct answer was %r" % ans
    print "="*72
    
def atomic():
    next = choice(elements.keys())
    print "What is the atomic number of the element %s (%s)?" % (elements[next]['name'],next)
    guess = raw_input("> ")
    if guess == 'exit' or guess == 'end':    exit(0)
    if guess == str(elements[next]['atomic']):
        print 'correct'
    else:
        answer(elements[next]['atomic'])
        
def mass():
    next = choice(elements.keys())
    print "What is the atomic mass of the elements %s (%s)?" % (elements[next]['name'],next)
    guess = raw_input("> ")
    if guess == 'exit' or guess == 'end':    exit(0)
    if guess == str(elements[next]['mass']):
        print 'correct'
        
    else:
        answer(elements[next]['mass'])


def classify():
    next = choice(elements.keys())
    print "What is the type (metal/non-metal) of the elements %s (%s)?" % (elements[next]['name'],next)
    guess = raw_input("> ")
    if guess == 'exit' or guess == 'end':    exit(0)
    if guess == str(elements[next]['type']):
        print 'correct'
    else:
        answer(elements[next]['type'])

def name():
    next = choice(elements.keys())
    print "What is the full name of the element %s?" % next
    guess = raw_input("> ")
    if guess == 'exit' or guess == 'end':    exit(0)
    if guess == elements[next]['name']:
        print 'correct'
    else:
        answer(elements[next]['name'])

def symbol():
    next = choice(elements.keys())
    print "What is the abbrevation of the element %s?" % elements[next]['name']
    guess = raw_input("> ")
    if guess == 'exit' or guess == 'end':    exit(0)
    if guess == next.capitalize() or guess == next or guess.lower() == elements[next]['alt']:
        print 'correct'
    else:
        answer(next)

def easy():
    while True:
        gen = randint(1,3)
        if gen == 1:
            classify()
        if gen == 2:
            name()
        if gen == 3:
            symbol()

def hard():
    while True:
        gen = randint(1,5)
        if gen == 1:
            classify()
        if gen == 2:
            name()
        if gen == 3:
            symbol()
        if gen == 4:
            mass()
        if gen == 5:
            atomic()
            
def start():
    print "1: Easy mode (guess symbols and names)"
    print "2: Hard mode (guess symbols, names, atomic masses, and atomic numbers)"
    dec = raw_input("> ")
    print "Type 'exit' or 'end' to leave the game"
    print "\n"
    if dec == '1' or 'eas' in dec:
        easy()
    if dec == '2' or 'har' in dec:
        hard()
        
if __name__ == '__main__':
    start()

