#!/usr/bin/env python
from sys import argv,exit
from elements import *

#invatomicmass = { 1.0079: 'H'}
#inv_pro = {1:'H'}
#symbols = {'krypton':'Kr'}


def find(element):
    element = converter(element)
    if type(element) == int:
        return inv_pro[element]
    if type(element) == float:
        return invatomicmass[element]
    if type(element) == str:
        if len(element) <= 2 and elements[element]:
            return element
        if len(element) > 2:
            return symbols[element]
    else:
        print "Error in find function"
    
def converter(element):
    
    try:
        for each in elements:
            if float(element) == elements[each]['mass']:
                return float(element)
    except ValueError:    pass
    
    try:
        for each in elements:
            if int(element) == elements[each]['atomic']:
                return int(element)
    except ValueError:    pass
    
    try:
        for each in elements:
            if element == elements[each]['name']:
                return element
    except ValueError:    pass
    
    try:
        if element.capitalize() in elements:
            return element.capitalize()
    except KeyError:    pass
    
def info(sym):
    try:
        v = elements[sym]
        print "Name: %s,%s" % (v['name'],sym)
        print "Atomic: %d" % v['atomic']
        print "Mass: %r" % v['mass']
        print "Charge: %r" % str(v['charge'])
        print "Type: %s" % v['type']
        print " "    
    except KeyError:
        pass 
    
    
class math(object):
    def __init__(self):
        print "Experimental math shell"
        print "Use 'end' or 'exit' to break loop"
        while True:
            
            try:
                ze_cmd= input("> ")
                if ze_cmd == 'exit' or ze_cmd == 'end':
                    print "Exiting experiment math shell"
                    break
                print ze_cmd
            except:
                print "Error in experimental math shell"
                pass    

def interactive():
    print "Interactive mode!\n"
    exp_sym = "+ = - / * math addition subtraction division multiplication".split()
    while True:
        ask = raw_input("> ")
        if ask == 'end' or ask == 'exit':
            print "Bye Bye!"
            exit(0)
        if "+" not in ask:
            info(find(ask))
        if "+" in ask:
            math()
                
                
                  
def help():
    print "\nfind() returns atomic symbols, if the input is in the dictionary. It tries for literals too."
    print "info() prints out info on the element given. Needs correct atomic symbol. Try find()."    
    print "arg1: Can be atomic mass, atomic #, name, or symbol. Prints out all information on that element if found."
    print "arg1 and arg2: arg1 = same as above, but only prints out the parameter given in arg2\n\tExample: python elem.py carbon name --> carbon"
    print "\tYou can use type, charge, name, symbol, or mass for 2nd arg.\n"
    
    
cmd = False
parameter = False

try:
    if argv[1]:    cmd = True
    if argv[2]:    parameter = True
except IndexError:    pass

if cmd and not parameter:
    cmd = argv[1]
    if cmd =='--help':    help()
    if cmd =='--math':
        math()
    if cmd != '--i' and cmd != '--help':
        sym = find(cmd)
        info(sym)
    if cmd == '--i':
        interactive()
if cmd and parameter:
    cmd = find(argv[1])
    parameter = argv[2]
    
    if parameter == 'name':    print elements[cmd]['name'], cmd
    if parameter == 'charge':    print elements[cmd]['charge']
    if parameter == 'type':    print elements[cmd]['type']
    if parameter == 'mass':    print elements[cmd]['mass']
    if parameter == 'atomic':    print elements[cmd]['atomic']
    if parameter == 'symbol':    print cmd

if __name__ == '__main__' and not cmd and not parameter:
    interactive()
